;;
;;    INFO  - Compile with FASM
;;

include "MACROS.INC"

    use32
    org    0x0

    db	   'MENUET01'	 ; 8 byte id
    dd	   0x01 	 ; header version
    dd	   START	 ; program start
    dd	   I_END	 ; size of image
    dd	   0x1000	 ; reguired amount of memory
    dd	   0x1000	 ; stack pointer
    dd	   0x0, 0x0	 ; reserved=no extended header


START:

    mov  eax, 40
    mov  ebx, 101b
    int  0x40

redraw:
    call draw_window

still:

    mov  eax,26
    mov  ebx,5
    int  0x40
    dec  eax

    mov  edx,[syslang]
    cmp  eax,edx
    jnz  redraw


    mov  eax,23 		; wait here for event
    mov  ebx,100
    int  0x40

    cmp  eax,1
    jz	 redraw
    cmp  eax,3
    jz	 button

    jmp  still


  button:

    or	 eax,-1    ; close this program
    int  0x40




draw_window:

    pusha

    mov  eax,12 		   ; tell os about redraw
    mov  ebx,1
    int  0x40

    mov  eax,0			   ; define and draw window
    mov  ebx,220*65536+270
    mov  ecx,40*65536+320
    mov  edx,0x03ffffff
    int  0x40

    ; info text

    mov  eax,26
    mov  ebx,5
    int  0x40

    dec  eax

    mov  [syslang],eax

push eax
    mov  eax, 4      ; write text
    mov  ebx, 8*65536+8
    mov  ecx, [tcl]		     ; 8b window nro - RR GG BB color
    mov  edx, labelt		    ; pointer to text beginning
    mov  esi, labellen-labelt	    ; text length
    int  0x40
pop  eax

    mov  edx, [pointers+eax*4]

    mov  ebx, 20*65536+35
    mov  ecx, [tc]
    add  edx, 4
    mov  eax, 4
  .nextstr:
    mov  esi, [edx-4]
    test esi, 0xFF000000
    jnz  .laststr
    int  0x40
    add  edx, esi
    add  edx, 4
    add  ebx, 10
    jmp  .nextstr
  .laststr:

    mov  eax,12 		   ; tell os about redraw end
    mov  ebx,2
    int  0x40

    popa

    ret





syslang dd 0x0
tc	dd 0x10000000
tcl	dd 0x10ffffff

pointers:
    dd text_eng
    dd text_fin
    dd text_ger
    dd text_rus

text_eng mstr \
     'Menuet Beta',\
     'Copyright(c)2004 Ville Turjanmaa',\
     '',\
     'Menuet is distributed under GPL',\
     'see file COPYING for details.',\
     '',\
     'eMail is welcome to',\
     '',\
     'villemt@silmu.jyu.fi',\
     '',\
     'for mailing me about develop-',\
     'ment or .. you name it.',\
     '',\
     'The diskette can be modified',\
     'in Wind*ws or Linux.',\
     '',\
     'Sources to all applications',\
     'and kernel are included to the',\
     'diskette. Compile with',\
     'FASM 1.50 and above.',\
     '',\
     'Menuet is fully written in',\
     '32 bit assembly.',\
     '',\
     'Sources:',\
     'www.menuetos.org'

text_fin mstr \
    'Menuet Beta',\
    'Copyright(c)2004 Ville Turjanmaa',\
    '',\
   <'Menuet k',193,'ytt',194,'j',193,'rjestelm',193,193,' voit'>,\
   <'jakaa ja k',193,'ytt',193,193,' vapaasti kunhan'>,\
    'GPL ehdot tayttyvat, /COPYING.',\
   <'S',193,'hk',194,'posti on tervetullutta'>,\
    '',\
    'villemt@silmu.jyu.fi',\
    '',\
   <'osotteeseen. Voit lahett',193,193>,\
    'postia asiasta kuin asiasta..',\
    '',\
   <'Levykett',193,' voit muokata henkil',194,'-'>,\
   <'kohtaiseen k',193,'ytt',194,194,'n mm. Linuxin'>,\
    'ja Windowsin avulla.',\
    '',\
   <'L',193,'hdekoodit kaikkiin ohjelmiin'>,\
   <'sek',193,' k',193,'ytt',194,'j',193,'rjestelm',193,193,'n'>,\
 <'ovat levyll',193,'. K',193,'yt',193,' k',193,193,'nt',193,'j',193,'n',193>,\
    'Fasm 1.50+',\
    '',\
   <'Menuet on t',193,'ysin kirjoitettu'>,\
   <'32 bit konekielell',193,'.'>,\
    '',\
   <'L',193,'hteet:'>,\
    'www.menuetos.org'


text_ger mstr \
     'Menuet Beta',\
     'Copyright(c)2004 Ville Turjanmaa',\
     '',\
     'Menuet ist GPL-ware, das heisst',\
     'man kann es frei verteilen,',\
     'solange die Copyright nicht',\
     'verndert wird.',\
     '',\
     'eMail willkommen an',\
     'villemt@silmu.jyu.fi',\
     '',\
     'zum mailen ber Entwicklung',\
     'oderber was auch immer ..',\
     '',\
     'Die Diskette kann unter Wind*ws',\
     'oder Linux verndert werden wenn',\
     'man den Kernel nicht verschiebt,',\
     'seine Position ist fix.',\
     '',\
     'Sources zu allen Applikationen',\
     'und zum Kernel sind auf der Disk',\
     'und zu kompilieren mit fasm',\
     '',\
     'Menuet ist ganz in',\
     '32 bit assembler geschrieben.',\
     '',\
     'Sources:',\
     'www.menuetos.org'

text_rus mstr \
     '  " N4"   ',\
     ' 樮 ⥬ ',\
     'Copyright(c)2004 Ville Turjanmaa',\
     '   ࠭ ',\
     '業 GPL. . COPYING.TXT',\
     '',\
     ' http://www.menuetos.org',\
     ' Ville Turjanmaa ( ) ',\
     ' Jarek Pelczar (뭥譨 ',\
     '  㪮⥫ ஥) ',\
     '',\
     'www.mario79.narod.ru/menuet.htm',\
     ' - ࠧࠡ稪 ⮣ ਡ',\
     '',\
     '   ᮤন',\
     '᪥  DOS, Windows  Linux.',\
     '',\
     '室   ணࠬ ',\
     ' http://www.meosfiles.narod.ru',\
     '   ',\
     'FASM 1.50+.',\
     '',\
     '᪮筠 প   ',\
     '㬥 http://meos.sysbin.com',\
     '',\
     '  ᠭ ',\
     '32-⭮ ᥬ.',\
     ''



labelt:
    db	 'MENUET OS (KOLIBRI N4) INFO'
labellen:

I_END: