;
;   GIF Include and Show Mini Sample by Pavlushin Evgeni for ASCL
;   Load bmp image from hd and show with macros
;   www.waptap@mail.ru
;


;******************************************************************************
    use32
    org    0x0
    db     'MENUET01'              ; 8 byte id
    dd     0x01                    ; header version
    dd     START                   ; start of code
    dd     IM_END                  ; size of image
    dd     I_END                   ; memory for app
    dd     I_END                   ; esp
    dd     0x0 , 0x0               ; I_Param , I_Icon

;******************************************************************************


include 'ascl.inc'
include 'ascgl.inc'


macro readmas masoff,obroff
{
local loo
    mov edi,masoff   ;tekoff
    add edi,8
    mov ebp,[masoff]   ;elements
    mov edx,[masoff+4] ;elemsize
    mov eax,0 ;count
loo:
    pushad
    call obroff
    popad
    add  edi,edx
    inc  eax
    cmp  eax,ebp
    jne  loo
}

macro findmas masoff,obroff
{
local loo,looend,lend
    mov edi,masoff   ;tekoff
    add edi,8
    mov ebp,[masoff]   ;elements
    mov edx,[masoff+4] ;elemsize
    mov eax,0 ;count
loo:
    pushad
    mov  eax,0
    call obroff
    cmp  eax,1
    je   looend
    popad
    add  edi,edx
    inc  eax
    cmp  eax,ebp
    jne  loo
    stc
    jmp  lend
looend:
    popad
    clc
lend:
}


randmas:
    push edi
    random 200,eax
    pop edi
    mov [edi],eax
    push edi
    random 200,eax
    pop edi
    mov [edi+4],eax
;    push edi
;    random 2,eax
;    pop edi
;    mov [edi+8],eax
    ret

showmas:
    cmp [edi+8],dword 0
    je  noshow
    setimg [edi],[edi+4],shoot
noshow:
    ret

delfarshoot:
    cmp [edi+4],dword 20
    ja  nodel
    mov [edi+8],dword 0
nodel:
    ret


movemas:
    dec dword [edi+4]
    ret

findzero:
    cmp [edi+8],dword 0
    je  iz_zero
    xor eax,eax
    ret
iz_zero:
    mov eax,1
    ret
    ret

START:                          ; start of execution

    mov eax,66
    mov ebx,1
    mov ecx,1
    int 0x40

    mov eax,26
    mov ebx,2
    mov ecx,1
    mov edx,keymap
    int 0x40


    readmas massive,randmas

;step1 define offset of hash area for unpacking gif file
;      size 16384+4 bytes
    gif_hash_offset = gif_hash_area
;step2 converting gif format to img format for easy out to screen
;      gif_file_area - offset of gif load file
;      img_area      - offset of img image
    giftoimg gif_file_area,img_area
;step3 out image from img_area
    getimg img_area,0,0,32,32,ship
    getimg img_area,32,0,32,32,shoot


    call draw_window

;Main loop wait for event with 10msec
still:
    timeevent 1,no_event,red,key,button
  no_event:

;    setimg 5,22,img_area
    readmas massive,showmas
    readmas massive,movemas
    readmas massive,delfarshoot
    findmas massive,findzero
;in edi off to free element
    jc  close_app
;    mov [edi+8],dword 2
;no_write:
    setimg [shipx],[shipy],ship
    jmp  still

  red:
    call draw_window
    jmp still

  key:                          ; key
    mov  eax,2
    int  0x40                   ; read (eax=2)

    shr eax,8
    and eax,0xff
    mov ah,al

    cmp ah,57 ;key_Space 85 exit
    jne no_space
    findmas massive,findzero
;in edi off to free element
    jc  close_app
    mov eax,[shipx]
    mov [edi],eax
    mov eax,[shipy]
    mov [edi+4],eax
    mov [edi+8],dword 1 ;show
no_space:
    cmp ah,75 ;key_Left
    jne no_left
    sub dword [shipx],4
no_left:
    cmp ah,77 ;key_Right
    jne no_right
    add dword [shipx],4
no_right:
    jmp  still                  ; not testing

  button:                       ; button
    mov  eax,17                 ; get id
    int  0x40
    cmp  ah,1                   ; button id=1 ?
    jne  noclose
close_app:
    mov  eax,-1                 ; close this program
    int  0x40
  noclose:
    jmp  still

draw_window:
    startwd
    window 40,40,(400+9),(240+26),window_Skinned+0x00ffffff
    label  8,8,'ASCL Incl&Show GIF Picture',cl_White+font_Big
;    setimg 5,22,img_area
    endwd
    ret

; DATA AREA
IM_END:
;massive
shipx dd 200
shipy dd 200

massive:
dd 100  ;elements num
dd 12  ;size of element in bytes
rb 100*12


keymap:
rb 10000

;gif_file_area ~21500
gif_file_area:
file 'star.gif';include gif file
rb 50          ;50 bytes temp back zone
img_area:
rb 128*32*3+8
ship:
rb 32*32*3+8
shoot:
rb 32*32*3+8
gif_hash_area:
rd 4096+1      ;hash area size for unpacking GIF
I_END:
